<?php

/*
 Plugin Name: EthereumICO
 Plugin URI: https://wordpress.org/plugins/ethereumico/
 Description: Sell your ERC20 ICO tokens from your WordPress site.
 Version: 2.3.12
 Author: ethereumicoio
 Text Domain: ethereum-ico
 Domain Path: /languages
*/
if ( !defined( 'ABSPATH' ) ) {
    exit;
}
// Exit if accessed directly
//use GuzzleHttp\Client;
//use GuzzleHttp\HandlerStack;
//use GuzzleHttp\Middleware;
//use GuzzleHttp\Psr7;
//use GuzzleHttp\Psr7\Request;
//use Psr\Http\Message\RequestInterface;
// Explicitly globalize to support bootstrapped WordPress
global 
    $ETHEREUM_ICO_plugin_basename,
    $ETHEREUM_ICO_options,
    $ETHEREUM_ICO_plugin_dir,
    $ETHEREUM_ICO_plugin_url_path,
    $ETHEREUM_ICO_services,
    $ETHEREUM_ICO_amp_icons_css
;

if ( function_exists( 'ethereumico_freemius_init' ) ) {
    ethereumico_freemius_init()->set_basename( false, __FILE__ );
} else {
    
    if ( !function_exists( 'ethereumico_freemius_init' ) ) {
        // Create a helper function for easy SDK access.
        function ethereumico_freemius_init()
        {
            global  $ethereumico_freemius_init ;
            
            if ( !isset( $ethereumico_freemius_init ) ) {
                // Include Freemius SDK.
                require_once dirname( __FILE__ ) . '/vendor/freemius/wordpress-sdk/start.php';
                $ethereumico_freemius_init = fs_dynamic_init( array(
                    'id'              => '4553',
                    'slug'            => 'ethereumico',
                    'premium_slug'    => 'ethereum-ico-premium',
                    'type'            => 'plugin',
                    'public_key'      => 'pk_d6ec6ed88408d88d05b66877dc81e',
                    'is_premium'      => false,
                    'premium_suffix'  => 'Premium',
                    'has_addons'      => false,
                    'has_paid_plans'  => true,
                    'trial'           => array(
                    'days'               => 7,
                    'is_require_payment' => true,
                ),
                    'has_affiliation' => 'all',
                    'menu'            => array(
                    'slug'   => 'ethereum-ico',
                    'parent' => array(
                    'slug' => 'options-general.php',
                ),
                ),
                    'is_live'         => true,
                ) );
            }
            
            return $ethereumico_freemius_init;
        }
        
        // Init Freemius.
        ethereumico_freemius_init();
        // Signal that SDK was initiated.
        do_action( 'ethereumico_freemius_init_loaded' );
    }
    
    // ... Your plugin's main file logic ...
    $ETHEREUM_ICO_plugin_basename = plugin_basename( dirname( __FILE__ ) );
    $ETHEREUM_ICO_plugin_dir = untrailingslashit( plugin_dir_path( __FILE__ ) );
    $ETHEREUM_ICO_plugin_url_path = untrailingslashit( plugin_dir_url( __FILE__ ) );
    // HTTPS?
    $ETHEREUM_ICO_plugin_url_path = ( is_ssl() ? str_replace( 'http:', 'https:', $ETHEREUM_ICO_plugin_url_path ) : $ETHEREUM_ICO_plugin_url_path );
    // Set plugin options
    $ETHEREUM_ICO_options = stripslashes_deep( get_option( 'ethereum-ico_options', array() ) );
    require $ETHEREUM_ICO_plugin_dir . '/vendor/autoload.php';
    function ETHEREUM_ICO_init()
    {
        global  $ETHEREUM_ICO_plugin_dir, $ETHEREUM_ICO_plugin_basename, $ETHEREUM_ICO_options ;
        // Load the textdomain for translations
        load_plugin_textdomain( 'ethereum-ico', false, $ETHEREUM_ICO_plugin_basename . '/languages/' );
    }
    
    add_filter( 'init', 'ETHEREUM_ICO_init' );
    function ETHEREUM_ICO_shortcode( $attributes )
    {
        global  $ETHEREUM_ICO_plugin_url_path ;
        global  $ETHEREUM_ICO_plugin_dir ;
        global  $ETHEREUM_ICO_options ;
        $attributes = shortcode_atts( array(
            'buybuttontext' => '',
            'minimum'       => '',
            'maximum'       => '',
            'step'          => '',
            'placeholder'   => '',
            'gaslimit'      => '',
            'tokenname'     => '',
            'description'   => '',
            'coinlist'      => '',
        ), $attributes, 'ethereum-ico' );
        $options = $ETHEREUM_ICO_options;
        $gaslimit = ( !empty($attributes['gaslimit']) ? $attributes['gaslimit'] : (( !empty($options['gaslimit']) ? esc_attr( $options['gaslimit'] ) : "200000" )) );
        $tokenName = ( !empty($attributes['tokenname']) ? $attributes['tokenname'] : (( !empty($options['tokenname']) ? esc_attr( $options['tokenname'] ) : "TESTCOIN" )) );
        $placeholder = ( !empty($attributes['placeholder']) ? $attributes['placeholder'] : (( !empty($options['placeholder']) ? esc_attr( $options['placeholder'] ) : __( "Input ETH amount", 'ethereum-ico' ) )) );
        $step = ( !empty($attributes['step']) ? $attributes['step'] : (( !empty($options['step']) ? esc_attr( $options['step'] ) : "0.1" )) );
        $minimum = ( !empty($attributes['minimum']) ? $attributes['minimum'] : (( !empty($options['min']) ? esc_attr( $options['min'] ) : "0" )) );
        $maximum = "1000000000";
        $buyButtonText = ( !empty($attributes['buybuttontext']) ? $attributes['buybuttontext'] : (( !empty($options['buyButtonText']) ? esc_attr( $options['buyButtonText'] ) : sprintf( __( "Buy %s with<br>Metamask", 'ethereum-ico' ), $tokenName ) )) );
        $description = ( !empty($attributes['description']) ? $attributes['description'] : (( !empty($options['description']) ? esc_attr( $options['description'] ) : sprintf(
            __( 'Make sure that you send %3$s from a wallet that supports %2$s tokens or from an address for which you control the private key. Otherwise you will not be able to interact with the %1$s tokens received. Do not send %3$s directly from an exchange to the ICO address.', 'ethereum-ico' ),
            $tokenName,
            ETHEREUM_ICO_getTokenStandardName(),
            ETHEREUM_ICO_getBlockchainCurrencyTickerName()
        ) )) );
        $coinList = ( !empty($attributes['coinlist']) ? $attributes['coinlist'] : (( !empty($options['coinList']) ? esc_attr( $options['coinList'] ) : '' )) );
        // remove all whitespaces
        $coinList = preg_replace( '/\\s+/', '', $coinList );
        $showIcons = ( !empty($options['showIcons']) ? esc_attr( $options['showIcons'] ) : '' );
        $base_currency = ( !empty($options['base_currency']) ? esc_attr( $options['base_currency'] ) : ETHEREUM_ICO_getBlockchainCurrencyTicker() );
        $base_currency_lower = strtolower( $base_currency );
        $base_currency_img = '';
        $ratesHtml = '';
        $coins = array();
        
        if ( $coinList ) {
            $coins = explode( ',', str_replace( " ", "", $coinList ) );
            $htmlArray = array();
            foreach ( $coins as $coin ) {
                $token = strtolower( $coin );
                $tokenImg = '';
                $html = '<div class="row ethereum-ico-rate-token-container">' . '<div class="ethereum-ico-rate-token-value col-md-5 col-6">' . '<span id="rate' . $token . '" class="ethereum-ico-rate ethereum-ico-coin-rate-' . sanitize_html_class( $token ) . '">0</span>' . '</div>' . '<div class="col-md-7 col-6">' . $tokenImg . '<span class="ethereum-ico-rate-coin float-left">' . $coin . '</span>' . '</div>' . '</div>';
                $htmlArray[] = $html;
            }
            $ratesHtml = '<h4 class="ethereum-ico-rate-token-container-wrapper">' . implode( "", $htmlArray ) . '</h4>';
        }
        
        $js = '';
        $ret = '<div class="twbs"><div class="container-fluid ethereum-ico-shortcode">
    <div class="row">
        <div class="col">
            <h2 class="ethereum-ico-gaslimit">' . sprintf( __( 'Gas Limit: %s', 'ethereum-ico' ), $gaslimit ) . '</h2>
        </div>
    </div>
    <div class="row">
        <div class="col-md-5 col-12">
            <div class="ethereum-ico-quantity">
                <input type="number" name="etherInput" id="etherInput" placeholder="' . $placeholder . '" step="' . $step . '" min="' . $minimum . '" max="' . $maximum . '" class="ethereum-ico-bottom-input-one">
                <div class="quantity-nav">
                    <div class="quantity-button quantity-up">
                        <i class="fa fa-chevron-up" aria-hidden="true"></i>
                    </div>
                    <div class="quantity-button quantity-down">
                        <i class="fa fa-chevron-down" aria-hidden="true"></i>
                    </div>
                </div>
            </div>
        </div>
        <div class="ethereum-ico-rate-token-value col-6 hidden-lg d-lg-none hidden-md d-md-none">
            <span id="rate' . $base_currency_lower . '" class="ethereum-ico-rate ethereum-ico-rate-eth ethereum-ico-coin-rate-' . sanitize_html_class( $base_currency_lower ) . '">0</span>
        </div>
        <div class="ethereum-ico-rate-eth col-6 hidden-lg d-lg-none hidden-md d-md-none">' . $base_currency_img . '<span class="ethereum-ico-rate-coin">' . $base_currency . '</span>
        </div>
        <div class="ethereum-ico-rate-eth col-md-2 col-md-offset-0 col-6 col-offset-6 visible-lg visible-md d-none d-md-block">' . $base_currency_img . '<span class="ethereum-ico-rate-coin">' . $base_currency . '</span>
        </div>
        <div class="ethereum-ico-bottom-button col-md-5 col-12">
            <button class="button ethereum-ico-bottom-button-two" id="buyTokensButton">' . $buyButtonText . '</button>
        </div>
    </div>' . $ratesHtml . '<div class="row">
        <div class="col">
            <p class="ethereum-ico-description">' . $description . '</p>
        </div>
    </div>
</div></div>';
        ETHEREUM_ICO_enqueue_scripts_();
        return $js . str_replace( "\n", " ", str_replace( "\r", " ", str_replace( "\t", " ", $ret ) ) );
    }
    
    add_shortcode( 'ethereum-ico', 'ETHEREUM_ICO_shortcode' );
    function ETHEREUM_ICO_input_currency_shortcode( $attributes )
    {
        global  $ETHEREUM_ICO_plugin_url_path ;
        global  $ETHEREUM_ICO_plugin_dir ;
        global  $ETHEREUM_ICO_options ;
        $attributes = shortcode_atts( array(
            'showicons'    => '',
            'basecurrency' => '',
        ), $attributes, 'ethereum-ico-input-currency' );
        $options = $ETHEREUM_ICO_options;
        $showIcons = ( !empty($attributes['showicons']) ? $attributes['showicons'] : (( !empty($options['showIcons']) ? esc_attr( $options['showIcons'] ) : "" )) );
        $base_currency = ( !empty($attributes['basecurrency']) ? $attributes['basecurrency'] : (( !empty($options['base_currency']) ? esc_attr( $options['base_currency'] ) : ETHEREUM_ICO_getBlockchainCurrencyTicker() )) );
        $base_currency_lower = strtolower( $base_currency );
        $base_currency_img = '';
        $js = '';
        $ret = '<div class="twbs"><div class="container-fluid ethereum-ico-shortcode ethereum-ico-input-currency-shortcode">
    <div class="row">
        <div class="ethereum-ico-rate-token-value col-6 hidden-lg d-lg-none hidden-md d-md-none">
            <span id="rate' . $base_currency_lower . '" class="ethereum-ico-rate ethereum-ico-rate-eth ethereum-ico-coin-rate-' . sanitize_html_class( $base_currency_lower ) . '">0</span>
        </div>
        <div class="ethereum-ico-rate-eth col-6 hidden-lg d-lg-none hidden-md d-md-none">' . $base_currency_img . '<span class="ethereum-ico-rate-coin">' . $base_currency . '</span>
        </div>
        <div class="ethereum-ico-rate-eth col-md-2 col-md-offset-0 col-6 col-offset-6 visible-lg visible-md d-none d-md-block">' . $base_currency_img . '<span class="ethereum-ico-rate-coin">' . $base_currency . '</span>
        </div>
    </div>
</div></div>';
        ETHEREUM_ICO_enqueue_scripts_();
        return $js . str_replace( "\n", " ", str_replace( "\r", " ", str_replace( "\t", " ", $ret ) ) );
    }
    
    add_shortcode( 'ethereum-ico-input-currency', 'ETHEREUM_ICO_input_currency_shortcode' );
    function ETHEREUM_ICO_limit_shortcode( $attributes )
    {
        global  $ETHEREUM_ICO_options ;
        $attributes = shortcode_atts( array(
            'label'    => '',
            'gaslimit' => '',
        ), $attributes, 'ethereum-ico-limit' );
        $options = $ETHEREUM_ICO_options;
        $gaslimit = ( !empty($attributes['gaslimit']) ? $attributes['gaslimit'] : (( !empty($options['gaslimit']) ? esc_attr( $options['gaslimit'] ) : "200000" )) );
        $label = ( !empty($attributes['label']) ? $attributes['label'] : __( 'Gas Limit: %s', 'ethereum-ico' ) );
        $js = '';
        $ret = '<div class="twbs"><div class="container-fluid ethereum-ico-shortcode ethereum-ico-limit-shortcode">
    <div class="row">
        <div class="col">
            <h2 class="ethereum-ico-gaslimit">' . sprintf( $label, $gaslimit ) . '</h2>
        </div>
    </div>
</div></div>';
        ETHEREUM_ICO_enqueue_scripts_();
        return $js . str_replace( "\n", " ", str_replace( "\r", " ", str_replace( "\t", " ", $ret ) ) );
    }
    
    add_shortcode( 'ethereum-ico-limit', 'ETHEREUM_ICO_limit_shortcode' );
    function ETHEREUM_ICO_buy_button_shortcode( $attributes )
    {
        global  $ETHEREUM_ICO_options ;
        $attributes = shortcode_atts( array(
            'buybuttontext' => '',
            'tokenname'     => '',
        ), $attributes, 'ethereum-ico-buy-button' );
        $options = $ETHEREUM_ICO_options;
        $tokenName = ( !empty($attributes['tokenname']) ? $attributes['tokenname'] : (( !empty($options['tokenname']) ? esc_attr( $options['tokenname'] ) : "TESTCOIN" )) );
        $buyButtonText = ( !empty($attributes['buybuttontext']) ? $attributes['buybuttontext'] : (( !empty($options['buyButtonText']) ? esc_attr( $options['buyButtonText'] ) : sprintf( __( "Buy %s with<br>Metamask", 'ethereum-ico' ), $tokenName ) )) );
        $js = '';
        $ret = '<div class="twbs"><div class="container-fluid ethereum-ico-shortcode ethereum-ico-buy-button-shortcode">
    <div class="row">
        <div class="ethereum-ico-bottom-button col-12">
            <button class="button ethereum-ico-bottom-button-two" id="buyTokensButton">' . $buyButtonText . '</button>
        </div>
    </div>
</div></div>';
        ETHEREUM_ICO_enqueue_scripts_();
        return $js . str_replace( "\n", " ", str_replace( "\r", " ", str_replace( "\t", " ", $ret ) ) );
    }
    
    add_shortcode( 'ethereum-ico-buy-button', 'ETHEREUM_ICO_buy_button_shortcode' );
    function ETHEREUM_ICO_currency_list_shortcode( $attributes )
    {
        global  $ETHEREUM_ICO_plugin_url_path ;
        global  $ETHEREUM_ICO_plugin_dir ;
        global  $ETHEREUM_ICO_options ;
        $attributes = shortcode_atts( array(
            'showicons' => 'true',
            'coinlist'  => '',
        ), $attributes, 'ethereum-ico-currency-list' );
        $options = $ETHEREUM_ICO_options;
        $coinList = ( !empty($attributes['coinlist']) ? $attributes['coinlist'] : (( !empty($options['coinList']) ? esc_attr( $options['coinList'] ) : '' )) );
        // remove all whitespaces
        $coinList = preg_replace( '/\\s+/', '', $coinList );
        $showIcons = ( !empty($attributes['showicons']) ? $attributes['showicons'] : (( !empty($options['showIcons']) ? esc_attr( $options['showIcons'] ) : "" )) );
        $base_currency = ( !empty($options['base_currency']) ? esc_attr( $options['base_currency'] ) : ETHEREUM_ICO_getBlockchainCurrencyTicker() );
        $base_currency_lower = strtolower( $base_currency );
        $base_currency_img = '';
        $ratesHtml = '';
        $coins = array();
        
        if ( $coinList ) {
            $coins = explode( ',', str_replace( " ", "", $coinList ) );
            $htmlArray = array();
            foreach ( $coins as $coin ) {
                $token = strtolower( $coin );
                $tokenImg = '';
                $html = '<div class="row ethereum-ico-rate-token-container">' . '<div class="ethereum-ico-rate-token-value col-md-5 col-6">' . '<span id="rate' . $token . '" class="ethereum-ico-rate ethereum-ico-coin-rate-' . sanitize_html_class( $token ) . '">0</span>' . '</div>' . '<div class="col-md-7 col-6">' . $tokenImg . '<span class="ethereum-ico-rate-coin float-left">' . $coin . '</span>' . '</div>' . '</div>';
                $htmlArray[] = $html;
            }
            $ratesHtml = '<h4 class="ethereum-ico-currency-list-rate-token-container-wrapper">' . implode( "", $htmlArray ) . '</h4>';
        }
        
        $js = '';
        $ret = '<div class="twbs"><div class="container-fluid ethereum-ico-shortcode ethereum-ico-currency-list-shortcode">' . $ratesHtml . '</div></div>';
        ETHEREUM_ICO_enqueue_scripts_();
        return $js . str_replace( "\n", " ", str_replace( "\r", " ", str_replace( "\t", " ", $ret ) ) );
    }
    
    add_shortcode( 'ethereum-ico-currency-list', 'ETHEREUM_ICO_currency_list_shortcode' );
    function ETHEREUM_ICO_input_shortcode( $attributes )
    {
        global  $ETHEREUM_ICO_plugin_url_path ;
        global  $ETHEREUM_ICO_plugin_dir ;
        global  $ETHEREUM_ICO_options ;
        $attributes = shortcode_atts( array(
            'minimum'     => '',
            'maximum'     => '',
            'step'        => '',
            'placeholder' => '',
        ), $attributes, 'ethereum-ico-input' );
        $options = $ETHEREUM_ICO_options;
        $placeholder = ( !empty($attributes['placeholder']) ? $attributes['placeholder'] : (( !empty($options['placeholder']) ? esc_attr( $options['placeholder'] ) : __( "Input ETH amount", 'ethereum-ico' ) )) );
        $step = ( !empty($attributes['step']) ? $attributes['step'] : (( !empty($options['step']) ? esc_attr( $options['step'] ) : "0.1" )) );
        $minimum = ( !empty($attributes['minimum']) ? $attributes['minimum'] : (( !empty($options['min']) ? esc_attr( $options['min'] ) : "0" )) );
        $maximum = "1000000000";
        $js = '';
        $ret = '<div class="twbs"><div class="container-fluid ethereum-ico-shortcode ethereum-ico-input-shortcode">
    <div class="row">
        <div class="col-12">
            <div class="ethereum-ico-quantity">
                <input type="number" name="etherInput" id="etherInput" placeholder="' . $placeholder . '" step="' . $step . '" min="' . $minimum . '" max="' . $maximum . '" class="ethereum-ico-bottom-input-one">
                <div class="quantity-nav">
                    <div class="quantity-button quantity-up">
                        <i class="fa fa-chevron-up" aria-hidden="true"></i>
                    </div>
                    <div class="quantity-button quantity-down">
                        <i class="fa fa-chevron-down" aria-hidden="true"></i>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div></div>';
        ETHEREUM_ICO_enqueue_scripts_();
        return $js . str_replace( "\n", " ", str_replace( "\r", " ", str_replace( "\t", " ", $ret ) ) );
    }
    
    add_shortcode( 'ethereum-ico-input', 'ETHEREUM_ICO_input_shortcode' );
    function ETHEREUM_ICO_calc_display_value( $value )
    {
        if ( $value < 1 ) {
            return array( 0.01 * round( 100 * $value ), '' );
        }
        if ( $value < 1000 ) {
            return array( 0.1 * round( 10 * $value ), '' );
        }
        if ( $value < 1000000 ) {
            return array( 0.1 * round( 10 * 0.001 * $value ), __( 'K', 'ethereum-ico' ) );
        }
        return array( 0.1 * round( 10 * 1.0E-6 * $value ), __( 'M', 'ethereum-ico' ) );
    }
    
    class ETHEREUM_ICO_Logger
    {
        /**
         * Add a log entry.
         *
         * This is not the preferred method for adding log messages. Please use log() or any one of
         * the level methods (debug(), info(), etc.). This method may be deprecated in the future.
         *
         * @param string $handle
         * @param string $message
         * @param string $level
         *
         * @see https://docs.woocommerce.com/wc-apidocs/source-class-WC_Logger.html#105
         *
         * @return bool
         */
        public function add( $handle, $message, $level = 'unused' )
        {
            error_log( $handle . ': ' . $message );
            return true;
        }
    
    }
    function ETHEREUM_ICO_log( $error )
    {
        static  $logger = false ;
        // Create a logger instance if we don't already have one.
        if ( false === $logger ) {
            /**
             * Check if WooCommerce is active
             * https://wordpress.stackexchange.com/a/193908/137915
             **/
            
            if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) && class_exists( "WC_Logger", false ) ) {
                $logger = new WC_Logger();
            } else {
                $logger = new ETHEREUM_ICO_Logger();
            }
        
        }
        $logger->add( 'ethereum-ico', $error );
    }
    
    function ETHEREUM_ICO_get_total_received_blockcypher( $crowdsaleAddress, $cacheKey )
    {
        $url = "https://api.blockcypher.com/v1/eth/main/addrs/{$crowdsaleAddress}/balance";
        $response = wp_remote_get( $url, array(
            'sslverify' => false,
        ) );
        ?>
        <!-- LOG: blockcypher.com API is called -->
        <?php 
        
        if ( is_wp_error( $response ) ) {
            $error_string = $response->get_error_message();
            ETHEREUM_ICO_log( "ETHEREUM_ICO_get_total_received_blockcypher({$crowdsaleAddress}):" . $error_string );
            return array( $error_string, null );
        }
        
        $http_code = wp_remote_retrieve_response_code( $response );
        
        if ( 200 != $http_code ) {
            ETHEREUM_ICO_log( "ETHEREUM_ICO_get_total_received_blockcypher({$crowdsaleAddress}): Result code is not 200" . $http_code );
            return array( __( "Result code is not 200", 'ethereum-ico' ), null );
        }
        
        $body = wp_remote_retrieve_body( $response );
        
        if ( !$body ) {
            ETHEREUM_ICO_log( "ETHEREUM_ICO_get_total_received_blockcypher({$crowdsaleAddress}): Empty body" );
            return array( __( "Empty body", 'ethereum-ico' ), null );
        }
        
        $j = json_decode( $body, true );
        
        if ( !isset( $j["total_received"] ) ) {
            ETHEREUM_ICO_log( "ETHEREUM_ICO_get_total_received_blockcypher({$crowdsaleAddress}): No total_received field" . $body );
            return array( __( "No total_received field", 'ethereum-ico' ), null );
        }
        
        $total_received = $j["total_received"];
        ?>
        <!-- LOG: blockcypher.com API call result is saved -->
    <?php 
        return array( null, $total_received );
    }
    
    function ETHEREUM_ICO_get_total_received_etherscan( $crowdsaleAddress, $cacheKey )
    {
        $url = sprintf( ETHEREUM_ICO_get_tx_list_api_url_template(), $crowdsaleAddress );
        //        ETHEREUM_ICO_log("ETHEREUM_ICO_get_total_received_etherscan($crowdsaleAddress):" . $url);
        $response = wp_remote_get( $url, array(
            'sslverify' => false,
        ) );
        ?>
        <!-- LOG: etherscan.io total_received API is called -->
        <?php 
        
        if ( is_wp_error( $response ) ) {
            $error_string = $response->get_error_message();
            ETHEREUM_ICO_log( "ETHEREUM_ICO_get_total_received_etherscan({$crowdsaleAddress}):" . $error_string );
            return array( $error_string, null );
        }
        
        $http_code = wp_remote_retrieve_response_code( $response );
        
        if ( 200 != $http_code ) {
            ETHEREUM_ICO_log( "ETHEREUM_ICO_get_total_received_etherscan({$crowdsaleAddress}): Result code is not 200" . $http_code );
            return array( __( "Result code is not 200", 'ethereum-ico' ), null );
        }
        
        $body = wp_remote_retrieve_body( $response );
        //        ETHEREUM_ICO_log("ETHEREUM_ICO_get_total_received_etherscan($crowdsaleAddress): body=" . $body);
        
        if ( !$body ) {
            ETHEREUM_ICO_log( "ETHEREUM_ICO_get_total_received_etherscan({$crowdsaleAddress}): Empty body" );
            return array( __( "Empty body", 'ethereum-ico' ), null );
        }
        
        $j = json_decode( $body, true );
        
        if ( !isset( $j["status"] ) ) {
            ETHEREUM_ICO_log( "ETHEREUM_ICO_get_total_received_etherscan({$crowdsaleAddress}): No status field" . $body );
            return array( __( "No status field", 'ethereum-ico' ), null );
        }
        
        
        if ( "1" !== $j["status"] ) {
            ETHEREUM_ICO_log( "ETHEREUM_ICO_get_total_received_etherscan({$crowdsaleAddress}): Bad status field" . $body );
            return array( __( "Bad status field", 'ethereum-ico' ), null );
        }
        
        
        if ( !isset( $j["result"] ) ) {
            ETHEREUM_ICO_log( "ETHEREUM_ICO_get_total_received_etherscan({$crowdsaleAddress}): No result field" . $body );
            return array( __( "No result field", 'ethereum-ico' ), null );
        }
        
        $trxns = $j["result"];
        $total_received = new phpseclib3\Math\BigInteger( 0 );
        foreach ( $trxns as $tx ) {
            $toAddress = $tx['to'];
            if ( strtolower( $toAddress ) != strtolower( $crowdsaleAddress ) ) {
                continue;
            }
            $value = $tx['value'];
            $total_received = $total_received->add( new phpseclib3\Math\BigInteger( $value ) );
        }
        ?>
        <!-- LOG: etherscan.io total_received API call result is stored -->
    <?php 
        return array( null, $total_received->toString() );
    }
    
    function _ETHEREUM_ICO_wei_to_ether( $balance )
    {
        $powDecimals = new phpseclib3\Math\BigInteger( pow( 10, 18 ) );
        list( $q, $r ) = $balance->divide( $powDecimals );
        $sR = $r->toString();
        $tokenDecimalChar = '.';
        $tokenDecimals = 18;
        $strBalanceDecimals = sprintf( '%018s', $sR );
        $strBalanceDecimals2 = substr( $strBalanceDecimals, 0, $tokenDecimals );
        
        if ( str_pad( "", $tokenDecimals, "0" ) == $strBalanceDecimals2 ) {
            $strBalance = rtrim( $q->toString() . $tokenDecimalChar . $strBalanceDecimals, '0' );
        } else {
            $strBalance = rtrim( $q->toString() . $tokenDecimalChar . $strBalanceDecimals2, '0' );
        }
        
        $strBalance = rtrim( $strBalance, $tokenDecimalChar );
        return $strBalance;
    }
    
    function ETHEREUM_ICO_progress_shortcode( $attributes )
    {
        //        global $ETHEREUM_ICO_plugin_url_path;
        global  $ETHEREUM_ICO_options ;
        $attributes = shortcode_atts( array(
            'crowdsale' => '',
            'softcap'   => '',
            'hardcap'   => '',
        ), $attributes, 'ethereum-ico' );
        $options = $ETHEREUM_ICO_options;
        //        $blockchain_network = ETHEREUM_ICO_getBlockchainNetwork();
        $crowdsaleAddress = ( !empty($attributes['crowdsale']) ? esc_attr( $attributes['crowdsale'] ) : (( !empty($options['crowdsaleAddress']) ? esc_attr( $options['crowdsaleAddress'] ) : "" )) );
        //        $icostart = !empty($attributes['icostart']) ? esc_attr($attributes['icostart']) :
        //                (!empty($options['icostart']) ? esc_attr($options['icostart']) : "");
        //
        //        $icoperiod = !empty($attributes['icoperiod']) ? esc_attr($attributes['icoperiod']) :
        //                (!empty($options['icoperiod']) ? esc_attr($options['icoperiod']) : "");
        $softcap = ( !empty($attributes['softcap']) ? esc_attr( $attributes['softcap'] ) : (( !empty($options['softcap']) ? esc_attr( $options['softcap'] ) : "" )) );
        $hardcap = ( !empty($attributes['hardcap']) ? esc_attr( $attributes['hardcap'] ) : (( !empty($options['hardcap']) ? esc_attr( $options['hardcap'] ) : "10000" )) );
        //
        ////	$base_currency = ! empty( $options['base_currency'] ) ? esc_attr( $options['base_currency'] ) : ETHEREUM_ICO_getBlockchainCurrencyTicker();
        //        $base_symbol = !empty($options['base_symbol']) ? esc_attr($options['base_symbol']) : '';
        //
        //        if ('' !== $softcap && doubleval($hardcap) <= doubleval($softcap)) {
        //            return '<div class="alert alert-warning"><strong>' . __('Warning!', 'ethereum-ico') . '</strong> ' . __('EthereumICO Progress is not configured properly. Check that softcap is less than hardcap.', 'ethereum-ico') . '</div>';
        //        }
        //
        //        $cacheKey = "$blockchain_network:$crowdsaleAddress:balance";
        //        $total_received = get_transient($cacheKey . "-ethereum-ico");
        //        if (false === $total_received) {
        //            $total_received = "0";
        //            switch ($blockchain_network) {
        //                case "mainnet":
        //                    list($error, $total_received) = ETHEREUM_ICO_get_total_received_blockcypher($crowdsaleAddress, $cacheKey);
        //                    if ($error) {
        //                        return '<div class="alert alert-danger"><strong>' . __('Error!', 'ethereum-ico') . '</strong> ' . $error . '</div>';
        //                    }
        //                    break;
        //
        //                default:
        //                    list($error, $total_received) = ETHEREUM_ICO_get_total_received_etherscan($crowdsaleAddress, $cacheKey);
        //                    if ($error) {
        //                        return '<div class="alert alert-danger"><strong>' . __('Error!', 'ethereum-ico') . '</strong> ' . $error . '</div>';
        //                    }
        //                    break;
        //            }
        //        }
        //
        //        $total_received_eth = _ETHEREUM_ICO_wei_to_ether(new phpseclib3\Math\BigInteger($total_received));
        //
        ?>
        <!-- total_received: <?php 
        // echo $total_received
        ?> -->
        <!-- total_received_eth: <?php 
        // echo $total_received_eth
        ?> -->
        <?php 
        //        // show only two digits after decimal point
        //        $total_received_eth_display = ETHEREUM_ICO_calc_display_value($total_received_eth);
        //        $total_received_eth_display = sprintf(__('%1$s%2$s%3$s', 'ethereum-ico'), $base_symbol, $total_received_eth_display[0], $total_received_eth_display[1]);
        //
        ?>
        <!-- total_received_eth_display: <?php 
        // echo $total_received_eth_display
        ?> -->
        <?php 
        //        $total_received_percent = 100 * $total_received_eth / doubleval($hardcap);
        //
        ?>
        <!-- total_received_percent: <?php 
        // echo $total_received_percent
        ?> -->
        <?php 
        //        $hardcap_display = ETHEREUM_ICO_calc_display_value(doubleval($hardcap));
        //        $hardcap_display = sprintf(__('%1$s%2$s%3$s', 'ethereum-ico'), $base_symbol, $hardcap_display[0], $hardcap_display[1]);
        //
        //        if ('' !== $softcap) {
        //            $soft_hard_percent = 100 * doubleval($softcap) / doubleval($hardcap);
        //            $soft_hard_remain_percent = (100 - $soft_hard_percent) / 2;
        //
        //            $softcap_display = ETHEREUM_ICO_calc_display_value(doubleval($softcap));
        //            $softcap_display = sprintf(__('%1$s%2$s%3$s', 'ethereum-ico'), $base_symbol, $softcap_display[0], $softcap_display[1]);
        //
        //            $js = '';
        //            // https://bootsnipp.com/snippets/featured/progress-bar-meter
        //            $ret =
        //'<div class="twbs"><div class="container-fluid ethereum-ico-progress-shortcode">
        //    <div class="row ethereum-ico-progress-content">
        //        <div class="col-12">
        //            <div class="progress">
        //                <div style="display:none" class="ethereum-ico-progress-total-received-eth">' . $total_received_eth . '</div>
        //                <div class="progress-bar ethereum-ico-progress-progress-bar" role="progressbar" aria-valuenow="' . $total_received_eth . '" aria-valuemin="0" aria-valuemax="' . $hardcap . '" style="width: ' . $total_received_percent . '%;" data-toggle="tooltip" data-placement="top" title="' . sprintf(__('%1$s%2$s', 'ethereum-ico'), $total_received_eth, ETHEREUM_ICO_getBlockchainCurrencyTicker()) . '">
        //                    <span class="sr-only ethereum-ico-progress-percent-complete">' . sprintf(__('%s%% Complete', 'ethereum-ico'), $total_received_percent) . '</span>
        //                </div>
        //            </div>
        //            <div class="progress-meter">
        //                <div class="meter meter-left" style="width: ' . $soft_hard_percent . '%;"><span class="meter-text ethereum-ico-progress-total-display">' . $total_received_eth_display . '</span></div>
        //                <div class="meter meter-left" style="width: ' . $soft_hard_remain_percent . '%;"><span class="meter-text">' . sprintf(__('Soft: %s', 'ethereum-ico'), '<span ethereum-ico-progress-softcap-display>' . $softcap_display . '</span>') . '</span></div>
        //                <div class="meter meter-right" style="width: ' . $soft_hard_remain_percent . '%;"><span class="meter-text">' . sprintf(__('Hard: %s', 'ethereum-ico'), '<span ethereum-ico-progress-hardcap-display>' . $hardcap_display . '</span>') . '</span></div>
        //            </div>
        //        </div>
        //    </div>
        //</div></div>';
        //        } else {
        //            $js = '';
        //            // https://bootsnipp.com/snippets/featured/progress-bar-meter
        //            $ret =
        //'<div class="twbs"><div class="container-fluid ethereum-ico-progress-shortcode">
        //    <div class="row ethereum-ico-progress-content">
        //        <div class="col-12">
        //            <div class="progress">
        //                <div style="display:none" class="ethereum-ico-progress-total-received-eth">' . $total_received_eth . '</div>
        //                <div class="progress-bar ethereum-ico-progress-progress-bar" role="progressbar" aria-valuenow="' . $total_received_eth . '" aria-valuemin="0" aria-valuemax="' . $hardcap . '" style="width: ' . $total_received_percent . '%;" data-toggle="tooltip" data-placement="top" title="' . sprintf(__('%1$s%2$s', 'ethereum-ico'), $total_received_eth, ETHEREUM_ICO_getBlockchainCurrencyTicker()) . '">
        //                    <span class="sr-only ethereum-ico-progress-percent-complete">' . sprintf(__('%s%% Complete', 'ethereum-ico'), $total_received_percent) . '</span>
        //                </div>
        //            </div>
        //            <div class="progress-meter">
        //                <div class="meter meter-left" style="width: 50%;"><span class="meter-text ethereum-ico-progress-total-display">' . $total_received_eth_display . '</span></div>
        //                <div class="meter meter-right" style="width: 50%;"><span class="meter-text">' . sprintf(__('Hard: %s', 'ethereum-ico'), '<span ethereum-ico-progress-hardcap-display>' . $hardcap_display . '</span>') . '</span></div>
        //            </div>
        //        </div>
        //    </div>
        //</div></div>';
        //        }
        ETHEREUM_ICO_enqueue_scripts_();
        $js = '';
        // https://bootsnipp.com/snippets/featured/progress-bar-meter
        $ret = '<div class="ethereum-ico-progress-shortcode-wrapper"' . ' data-crowdsale="' . $crowdsaleAddress . '" ' . ' data-softcap="' . $softcap . '" ' . ' data-hardcap="' . $hardcap . '" ' . '></div>';
        return $js . str_replace( "\n", " ", str_replace( "\r", " ", str_replace( "\t", " ", $js . $ret ) ) );
    }
    
    add_shortcode( 'ethereum-ico-progress', 'ETHEREUM_ICO_progress_shortcode' );
    function ETHEREUM_ICO_progress_value_shortcode( $attributes )
    {
        global  $ETHEREUM_ICO_options ;
        $attributes = shortcode_atts( array(
            'crowdsale' => '',
        ), $attributes, 'ethereum-ico' );
        $options = $ETHEREUM_ICO_options;
        $blockchain_network = ETHEREUM_ICO_getBlockchainNetwork();
        $crowdsaleAddress = ( !empty($attributes['crowdsale']) ? esc_attr( $attributes['crowdsale'] ) : (( !empty($options['crowdsaleAddress']) ? esc_attr( $options['crowdsaleAddress'] ) : "" )) );
        $cacheKey = "{$blockchain_network}:{$crowdsaleAddress}:balance";
        $total_received = get_transient( $cacheKey . "-ethereum-ico" );
        if ( false === $total_received ) {
            switch ( $blockchain_network ) {
                case "mainnet":
                    list( $error, $total_received ) = ETHEREUM_ICO_get_total_received_blockcypher( $crowdsaleAddress, $cacheKey );
                    if ( $error ) {
                        return '<div class="alert alert-danger"><strong>' . __( 'Error!', 'ethereum-ico' ) . '</strong> ' . $error . '</div>';
                    }
                    break;
                default:
                    list( $error, $total_received ) = ETHEREUM_ICO_get_total_received_etherscan( $crowdsaleAddress, $cacheKey );
                    if ( $error ) {
                        return '<div class="alert alert-danger"><strong>' . __( 'Error!', 'ethereum-ico' ) . '</strong> ' . $error . '</div>';
                    }
                    break;
            }
        }
        $total_received_eth = _ETHEREUM_ICO_wei_to_ether( new phpseclib3\Math\BigInteger( $total_received ) );
        $js = '';
        // https://bootsnipp.com/snippets/featured/progress-bar-meter
        $ret = '<div class="twbs"><div class="container-fluid ethereum-ico-progress-shortcode ethereum-ico-progress-value-shortcode">
    <div class="row ethereum-ico-progress-content ethereum-ico-progress-value-content">
        <div class="col-12">
            <div style="display:none" class="ethereum-ico-progress-value-total-received-eth">' . $total_received_eth . '</div>
            <div class="ethereum-ico-progress-value-total-display">' . $total_received_eth . ' ETH</div>
        </div>
    </div>
</div></div>';
        ETHEREUM_ICO_enqueue_scripts_();
        return $js . str_replace( "\n", " ", str_replace( "\r", " ", str_replace( "\t", " ", $js . $ret ) ) );
    }
    
    add_shortcode( 'ethereum-ico-progress-value', 'ETHEREUM_ICO_progress_value_shortcode' );
    function ETHEREUM_ICO_progress_percent_shortcode( $attributes )
    {
        global  $ETHEREUM_ICO_options ;
        $attributes = shortcode_atts( array(
            'crowdsale' => '',
            'hardcap'   => '',
        ), $attributes, 'ethereum-ico' );
        $options = $ETHEREUM_ICO_options;
        $blockchain_network = ETHEREUM_ICO_getBlockchainNetwork();
        $crowdsaleAddress = ( !empty($attributes['crowdsale']) ? esc_attr( $attributes['crowdsale'] ) : (( !empty($options['crowdsaleAddress']) ? esc_attr( $options['crowdsaleAddress'] ) : "" )) );
        $hardcap = ( !empty($attributes['hardcap']) ? esc_attr( $attributes['hardcap'] ) : (( !empty($options['hardcap']) ? esc_attr( $options['hardcap'] ) : "10000" )) );
        $cacheKey = "{$blockchain_network}:{$crowdsaleAddress}:balance";
        $total_received = get_transient( $cacheKey . "-ethereum-ico" );
        if ( false === $total_received ) {
            switch ( $blockchain_network ) {
                case "mainnet":
                    list( $error, $total_received ) = ETHEREUM_ICO_get_total_received_blockcypher( $crowdsaleAddress, $cacheKey );
                    if ( $error ) {
                        return '<div class="alert alert-danger"><strong>' . __( 'Error!', 'ethereum-ico' ) . '</strong> ' . $error . '</div>';
                    }
                    break;
                default:
                    list( $error, $total_received ) = ETHEREUM_ICO_get_total_received_etherscan( $crowdsaleAddress, $cacheKey );
                    if ( $error ) {
                        return '<div class="alert alert-danger"><strong>' . __( 'Error!', 'ethereum-ico' ) . '</strong> ' . $error . '</div>';
                    }
                    break;
            }
        }
        $total_received_eth = _ETHEREUM_ICO_wei_to_ether( new phpseclib3\Math\BigInteger( $total_received ) );
        $total_received_percent = 100 * $total_received_eth / doubleval( $hardcap );
        $js = '';
        // https://bootsnipp.com/snippets/featured/progress-bar-meter
        $ret = '<div class="twbs"><div class="container-fluid ethereum-ico-progress-shortcode ethereum-ico-progress-percent-shortcode">
    <div class="row ethereum-ico-progress-content ethereum-ico-progress-percent-content">
        <div class="col-12">
            <div style="display:none" class="ethereum-ico-progress-percent-total-received-eth">' . $total_received_eth . '</div>
            <div><span class="ethereum-ico-progress-percent-display">' . $total_received_percent . '</span><span class="ethereum-ico-progress-percent-display-percent">%</span></div>
        </div>
    </div>
</div></div>';
        ETHEREUM_ICO_enqueue_scripts_();
        return $js . str_replace( "\n", " ", str_replace( "\r", " ", str_replace( "\t", " ", $js . $ret ) ) );
    }
    
    add_shortcode( 'ethereum-ico-progress-percent', 'ETHEREUM_ICO_progress_percent_shortcode' );
    function ETHEREUM_ICO_balance_shortcode( $attributes )
    {
        global  $ETHEREUM_ICO_plugin_url_path ;
        global  $ETHEREUM_ICO_options ;
        $attributes = shortcode_atts( array(
            'tokenname'   => '',
            'label'       => __( 'Account', 'ethereum-ico' ),
            'placeholder' => __( 'Input your ethereum account address', 'ethereum-ico' ),
        ), $attributes, 'ethereum-ico' );
        $options = $ETHEREUM_ICO_options;
        $tokenName = ( !empty($attributes['tokenname']) ? $attributes['tokenname'] : (( !empty($options['tokenname']) ? esc_attr( $options['tokenname'] ) : "TESTCOIN" )) );
        $label = ( !empty($attributes['label']) ? $attributes['label'] : __( 'Account', 'ethereum-ico' ) );
        $placeholder = ( !empty($attributes['placeholder']) ? $attributes['placeholder'] : __( 'Input your ethereum account address', 'ethereum-ico' ) );
        $js = '';
        $ret = '<div class="twbs"><div class="container-fluid ethereum-ico-balance-shortcode">
    <div class="row ethereum-ico-balance-account-wrapper">
        <div class="col-12">
            <div class="form-group">
                <label class="control-label" for="ethereum-ico-balance-account">' . $label . '</label>
                <div class="input-group" style="margin-top: 8px">
                    <input type="text"
                           value=""
                           placeholder="' . $placeholder . '"
                           id="ethereum-ico-balance-account"
                           class="form-control">
                </div>
            </div>
        </div>
    </div>
    <div class="row ethereum-ico-balance-content">
        <div class="col-md-6 col-6 ethereum-ico-balance-value-wrapper">
            <div class="ethereum-ico-balance-value">0</div>
        </div>
        <div class="col-md-6 col-6 ethereum-ico-balance-token-name-wrapper">
            <div class="ethereum-ico-balance-token-name">' . $tokenName . '</div>
        </div>
    </div>
</div></div>';
        ETHEREUM_ICO_enqueue_scripts_();
        return $js . str_replace( "\n", " ", str_replace( "\r", " ", str_replace( "\t", " ", $js . $ret ) ) );
    }
    
    add_shortcode( 'ethereum-ico-balance', 'ETHEREUM_ICO_balance_shortcode' );
    function ETHEREUM_ICO_referral_shortcode( $attributes )
    {
        global  $ETHEREUM_ICO_plugin_url_path ;
        global  $ETHEREUM_ICO_options ;
        $attributes = shortcode_atts( array(
            'url'         => '',
            'label'       => __( 'Account', 'ethereum-ico' ),
            'placeholder' => __( 'Input your ethereum account address', 'ethereum-ico' ),
        ), $attributes, 'ethereum-ico' );
        $options = $ETHEREUM_ICO_options;
        $url = ( !empty($attributes['url']) ? $attributes['url'] : '' );
        $label = ( !empty($attributes['label']) ? $attributes['label'] : __( 'Account', 'ethereum-ico' ) );
        $placeholder = ( !empty($attributes['placeholder']) ? $attributes['placeholder'] : __( 'Input your ethereum account address', 'ethereum-ico' ) );
        $js = '';
        $ret = '<div class="twbs"><div class="container-fluid ethereum-ico-referral-shortcode">
    <div class="row ethereum-ico-referral-account-wrapper">
        <div class="col-12">
            <div class="form-group">
                <label class="control-label" for="ethereum-ico-referral-account">' . $label . '</label>
                <div class="input-group" style="margin-top: 8px">
                    <input type="text"
                           value=""
                           placeholder="' . $placeholder . '"
                           id="ethereum-ico-referral-account"
                           class="form-control">
                </div>
            </div>
        </div>
    </div>
    <div class="row ethereum-ico-referral-content">
        <div class="col-12">
            <div class="form-group">
                <label class="control-label" for="ethereum-ico-referral-link">' . __( 'Referral link', 'ethereum-ico' ) . '</label>
                <div class="input-group" style="margin-top: 8px">
                    <input type="hidden"
                           value="' . $url . '"
                           id="ethereum-ico-referral-url">
                    <input style="cursor: text;" type="text" disabled="disabled"
                           value=""
                           data-clipboard-action="copy"
                           id="ethereum-ico-referral-link"
                           class="form-control">
                    <span class="input-group-btn">
                        <button class="button btn btn-default ico-copy-button" type="button"
                                data-input-id="ethereum-ico-referral-link"
                                title="' . __( 'Copy', 'ethereum-ico' ) . '">
                            <i class="fa fa-clipboard" aria-hidden="true"></i>
                        </button>
                    </span>
                </div>
            </div>
        </div>
    </div>
</div></div>';
        ETHEREUM_ICO_enqueue_scripts_();
        return $js . str_replace( "\n", " ", str_replace( "\r", " ", str_replace( "\t", " ", $js . $ret ) ) );
    }
    
    add_shortcode( 'ethereum-ico-referral', 'ETHEREUM_ICO_referral_shortcode' );
    function ETHEREUM_ICO_purchases_shortcode( $attributes )
    {
        global  $ETHEREUM_ICO_plugin_url_path ;
        global  $ETHEREUM_ICO_options ;
        $attributes = shortcode_atts( array(
            'tokenname'   => '',
            'label'       => __( 'Account', 'ethereum-ico' ),
            'placeholder' => __( 'Input your ethereum account address', 'ethereum-ico' ),
        ), $attributes, 'ethereum-ico' );
        $options = $ETHEREUM_ICO_options;
        $tokenName = ( !empty($attributes['tokenname']) ? $attributes['tokenname'] : (( !empty($options['tokenname']) ? esc_attr( $options['tokenname'] ) : "TESTCOIN" )) );
        $label = ( !empty($attributes['label']) ? $attributes['label'] : __( 'Account', 'ethereum-ico' ) );
        $placeholder = ( !empty($attributes['placeholder']) ? $attributes['placeholder'] : __( 'Input your ethereum account address', 'ethereum-ico' ) );
        $js = '';
        $ret = '<div class="twbs"><div class="container-fluid ethereum-ico-purchases-shortcode">
    <div class="row ethereum-ico-purchases-account-chk-wrapper">
        <div class="col-12">
            <div class="form-check form-check-inline">
                <input type="checkbox"
                       value=""
                       id="ethereum-ico-purchases-account-chk"
                       class="form-check-input">
                <label class="form-check-label" for="ethereum-ico-purchases-account-chk">' . __( 'My account only', 'ethereum-ico' ) . '</label>
            </div>
        </div>
    </div>
    <div class="row ethereum-ico-purchases-account-wrapper hidden" hidden>
        <div class="col-12">
            <div class="form-group">
                <label class="control-label" for="ethereum-ico-purchases-account">' . $label . '</label>
                <div class="input-group" style="margin-top: 8px">
                    <input type="text"
                           value=""
                           placeholder="' . $placeholder . '"
                           id="ethereum-ico-purchases-account"
                           class="form-control">
                </div>
            </div>
        </div>
    </div>
    <div class="row ethereum-ico-purchases-table-wrapper">
        <div class="col-12">
            <div class="table-responsive">
                <table class="table table-striped table-condensed ethereum-ico-purchases-table">
                    <thead>
                        <tr>
                            <th>' . __( '#', 'ethereum-ico' ) . '</th>
                            <th>' . __( 'Amount', 'ethereum-ico' ) . '</th>
                            <th>' . sprintf( __( 'Amount, %s', 'ethereum-ico' ), $tokenName ) . '</th>
                            <th>' . __( 'Date', 'ethereum-ico' ) . '</th>
                            <th>' . __( 'Tx', 'ethereum-ico' ) . '</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div></div>';
        ETHEREUM_ICO_enqueue_scripts_();
        return $js . str_replace( "\n", " ", str_replace( "\r", " ", str_replace( "\t", " ", $js . $ret ) ) );
    }
    
    add_shortcode( 'ethereum-ico-purchases', 'ETHEREUM_ICO_purchases_shortcode' );
    function ETHEREUM_ICO_enqueue_scripts_()
    {
        wp_enqueue_style( 'ethereum-ico' );
        //        wp_enqueue_script('web3');
        wp_enqueue_script( 'ethereum-ico-main' );
    }
    
    function ETHEREUM_ICO_stylesheet()
    {
        global  $ETHEREUM_ICO_plugin_url_path ;
        $deps = array( 'font-awesome', 'bootstrap-ethereum-ico' );
        $min = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ? '' : '.min' );
        
        if ( !wp_style_is( 'font-awesome', 'queue' ) && !wp_style_is( 'font-awesome', 'done' ) ) {
            wp_dequeue_style( 'font-awesome' );
            wp_deregister_style( 'font-awesome' );
            wp_register_style(
                'font-awesome',
                $ETHEREUM_ICO_plugin_url_path . "/css/font-awesome{$min}.css",
                array(),
                '4.7.0'
            );
        }
        
        
        if ( !wp_style_is( 'bootstrap-ethereum-ico', 'queue' ) && !wp_style_is( 'bootstrap-ethereum-ico', 'done' ) ) {
            wp_dequeue_style( 'bootstrap-ethereum-ico' );
            wp_deregister_style( 'bootstrap-ethereum-ico' );
            wp_register_style(
                'bootstrap-ethereum-ico',
                $ETHEREUM_ICO_plugin_url_path . "/css/bootstrap-ns{$min}.css",
                array(),
                '4.0.0'
            );
        }
        
        
        if ( !wp_style_is( 'ethereum-ico', 'queue' ) && !wp_style_is( 'ethereum-ico', 'done' ) ) {
            wp_dequeue_style( 'ethereum-ico' );
            wp_deregister_style( 'ethereum-ico' );
            wp_register_style(
                'ethereum-ico',
                $ETHEREUM_ICO_plugin_url_path . '/ethereum-ico.css',
                $deps,
                '2.3.12'
            );
        }
    
    }
    
    add_action( 'wp_enqueue_scripts', 'ETHEREUM_ICO_stylesheet', 20 );
    function ETHEREUM_ICO_get_rate_data_fiat()
    {
        global  $ETHEREUM_ICO_options ;
        if ( empty($ETHEREUM_ICO_options['openexchangeratesAppId']) ) {
            return "null";
        }
        $openexchangeratesAppId = esc_attr( $ETHEREUM_ICO_options['openexchangeratesAppId'] );
        $openexchangeratesEndpoint = "https://openexchangerates.org/api/latest.json?app_id=" . $openexchangeratesAppId;
        $rateDataFiat = get_transient( "openexchangerates_rate_data-ethereum-ico" );
        
        if ( false === $rateDataFiat ) {
            $rateDataFiat = "null";
            $response = wp_remote_get( $openexchangeratesEndpoint, array(
                'sslverify' => false,
            ) );
            ?>
            <!-- LOG: openexchangerates.org API is called -->
            <?php 
            
            if ( !is_wp_error( $response ) ) {
                $http_code = wp_remote_retrieve_response_code( $response );
                
                if ( 200 == $http_code ) {
                    $body = wp_remote_retrieve_body( $response );
                    
                    if ( $body ) {
                        $j = json_decode( $body, true );
                        
                        if ( isset( $j["rates"] ) ) {
                            //  "rates": {
                            //    "AED": 3.672896,
                            //    "AFN": 69.496503,
                            //    "ALL": 107.678684,
                            $rateDataFiat = json_encode( $j["rates"] );
                            ?>
                            <!-- LOG: openexchangerates.org API call result is saved -->
        <?php 
                        }
                    
                    }
                
                }
            
            }
        
        }
        
        return $rateDataFiat;
    }
    
    function ETHEREUM_ICO_get_rate_data()
    {
        //        global $ETHEREUM_ICO_options;
        $url = ETHEREUM_ICO_get_ethprice_api_url();
        $rateData = get_transient( "rate_data-ethereum-ico" );
        if ( false !== $rateData ) {
            return [ null, $rateData ];
        }
        //        ETHEREUM_ICO_log("ETHEREUM_ICO_get_rate_data:" . $url);
        $response = wp_remote_get( $url, array(
            'sslverify' => false,
        ) );
        ?>
        <!-- LOG: etherscan.io total_received API is called -->
        <?php 
        
        if ( is_wp_error( $response ) ) {
            $error_string = $response->get_error_message();
            ETHEREUM_ICO_log( "ETHEREUM_ICO_get_rate_data:" . $error_string );
            return array( $error_string, null );
        }
        
        $http_code = wp_remote_retrieve_response_code( $response );
        
        if ( 200 != $http_code ) {
            ETHEREUM_ICO_log( "ETHEREUM_ICO_get_rate_data: Result code is not 200" . $http_code );
            return array( __( "Result code is not 200", 'ethereum-ico' ), null );
        }
        
        $body = wp_remote_retrieve_body( $response );
        //        ETHEREUM_ICO_log("ETHEREUM_ICO_get_rate_data: body=" . $body);
        
        if ( !$body ) {
            ETHEREUM_ICO_log( "ETHEREUM_ICO_get_rate_data: Empty body" );
            return array( __( "Empty body", 'ethereum-ico' ), null );
        }
        
        $j = json_decode( $body, true );
        
        if ( !isset( $j["status"] ) ) {
            ETHEREUM_ICO_log( "ETHEREUM_ICO_get_rate_data: No status field" . $body );
            return array( __( "No status field", 'ethereum-ico' ), null );
        }
        
        
        if ( "1" !== $j["status"] ) {
            ETHEREUM_ICO_log( "ETHEREUM_ICO_get_rate_data: Bad status field" . $body );
            return array( __( "Bad status field", 'ethereum-ico' ), null );
        }
        
        
        if ( !isset( $j["result"] ) ) {
            ETHEREUM_ICO_log( "ETHEREUM_ICO_get_rate_data: No result field" . $body );
            return array( __( "No result field", 'ethereum-ico' ), null );
        }
        
        $rateData = json_encode( $j["result"] );
        if ( empty($rateData) ) {
            $rateData = "null";
        }
        ?>
        <!-- LOG: etherscan.io total_received API call result is stored -->
<?php 
        return array( null, $rateData );
    }
    
    function ETHEREUM_ICO_getBlockchainNetwork()
    {
        global  $ETHEREUM_ICO_options ;
        $blockchainNetwork = 'mainnet';
        if ( !isset( $ETHEREUM_ICO_options['blockchain_network'] ) ) {
            return $blockchainNetwork;
        }
        if ( empty($ETHEREUM_ICO_options['blockchain_network']) ) {
            return $blockchainNetwork;
        }
        $blockchainNetwork = esc_attr( $ETHEREUM_ICO_options['blockchain_network'] );
        return $blockchainNetwork;
    }
    
    function ETHEREUM_ICO_getWeb3Endpoint()
    {
        global  $ETHEREUM_ICO_options ;
        $infuraApiKey = ( isset( $ETHEREUM_ICO_options['infuraApiKey'] ) ? esc_attr( $ETHEREUM_ICO_options['infuraApiKey'] ) : '' );
        $blockchainNetwork = ETHEREUM_ICO_getBlockchainNetwork();
        if ( empty($blockchainNetwork) ) {
            $blockchainNetwork = 'mainnet';
        }
        $web3Endpoint = "https://" . esc_attr( $blockchainNetwork ) . ".infura.io/v3/" . esc_attr( $infuraApiKey );
        return $web3Endpoint;
    }
    
    function ETHEREUM_ICO_getBlockchainCurrencyTicker()
    {
        global  $ETHEREUM_ICO_options ;
        $currency_ticker = "ETH";
        return $currency_ticker;
    }
    
    function ETHEREUM_ICO_getBlockchainCurrencyTickerName()
    {
        global  $ETHEREUM_ICO_options ;
        $currency_ticker_name = "Ether";
        return $currency_ticker_name;
    }
    
    function ETHEREUM_ICO_getTokenStandardName()
    {
        global  $ETHEREUM_ICO_options ;
        $token_standard_name = "ERC20";
        return $token_standard_name;
    }
    
    function ETHEREUM_ICO_get_txhash_path( $txHash )
    {
        return sprintf( ETHEREUM_ICO_get_txhash_path_template(), $txHash );
    }
    
    function ETHEREUM_ICO_get_txhash_path_template()
    {
        global  $ETHEREUM_ICO_options ;
        $blockchainNetwork = ETHEREUM_ICO_getBlockchainNetwork();
        $txHashPath = '%s';
        switch ( $blockchainNetwork ) {
            case 'mainnet':
                $txHashPath = 'https://etherscan.io/tx/%s';
                break;
            case 'ropsten':
                $txHashPath = 'https://ropsten.etherscan.io/tx/%s';
                break;
            case 'rinkeby':
                $txHashPath = 'https://rinkeby.etherscan.io/tx/%s';
                break;
            case 'goerli':
                $txHashPath = 'https://goerli.etherscan.io/tx/%s';
            case 'kovan':
                $txHashPath = 'https://kovan.etherscan.io/tx/%s';
                break;
            case 'bsc':
                $txHashPath = 'https://bscscan.com/tx/%s';
                break;
            case 'bsctest':
                $txHashPath = 'https://testnet.bscscan.com/tx/%s';
                break;
            default:
                break;
        }
        return $txHashPath;
    }
    
    function ETHEREUM_ICO_get_address_path( $address )
    {
        return sprintf( ETHEREUM_ICO_get_address_path_template(), $address );
    }
    
    function ETHEREUM_ICO_get_address_path_template()
    {
        global  $ETHEREUM_ICO_options ;
        $blockchainNetwork = ETHEREUM_ICO_getBlockchainNetwork();
        $addressPath = '%s';
        switch ( $blockchainNetwork ) {
            case 'mainnet':
                $addressPath = 'https://etherscan.io/address/%s';
                break;
            case 'ropsten':
                $addressPath = 'https://ropsten.etherscan.io/address/%s';
                break;
            case 'rinkeby':
                $addressPath = 'https://rinkeby.etherscan.io/address/%s';
                break;
            case 'goerli':
                $addressPath = 'https://goerli.etherscan.io/address/%s';
            case 'kovan':
                $addressPath = 'https://kovan.etherscan.io/address/%s';
                break;
            case 'bsc':
                $txHashPath = 'https://bscscan.com/address/%s';
                break;
            case 'bsctest':
                $txHashPath = 'https://testnet.bscscan.com/address/%s';
                break;
            default:
                break;
        }
        return $addressPath;
    }
    
    function ETHEREUM_ICO_get_tx_list_api_url_template()
    {
        global  $ETHEREUM_ICO_options ;
        $blockchainNetwork = ETHEREUM_ICO_getBlockchainNetwork();
        $options = stripslashes_deep( $ETHEREUM_ICO_options );
        $etherscanApiKey = ( !empty($options['etherscanApiKey']) ? esc_attr( $options['etherscanApiKey'] ) : '' );
        $blockchain_network = '';
        if ( 'mainnet' !== $blockchainNetwork ) {
            $blockchain_network = '-' . $blockchainNetwork;
        }
        $tx_list_api_url = 'https://api' . $blockchain_network . '.etherscan.io/api?module=account&action=txlist&address=%s&startblock=0&endblock=99999999&sort=desc&apikey=' . $etherscanApiKey;
        return $tx_list_api_url;
    }
    
    function ETHEREUM_ICO_get_internal_tx_list_api_url_template()
    {
        global  $ETHEREUM_ICO_options ;
        $blockchainNetwork = ETHEREUM_ICO_getBlockchainNetwork();
        $options = stripslashes_deep( $ETHEREUM_ICO_options );
        $etherscanApiKey = ( !empty($options['etherscanApiKey']) ? esc_attr( $options['etherscanApiKey'] ) : '' );
        $blockchain_network = '';
        if ( 'mainnet' !== $blockchainNetwork ) {
            $blockchain_network = '-' . $blockchainNetwork;
        }
        $internal_tx_list_api_url = 'https://api' . $blockchain_network . '.etherscan.io/api?module=account&action=txlistinternal&address=%s&startblock=0&endblock=99999999&sort=desc&apikey=' . $etherscanApiKey;
        return $internal_tx_list_api_url;
    }
    
    function ETHEREUM_ICO_get_token_tx_list_api_url_template()
    {
        global  $ETHEREUM_ICO_options ;
        $blockchainNetwork = ETHEREUM_ICO_getBlockchainNetwork();
        $options = stripslashes_deep( $ETHEREUM_ICO_options );
        $etherscanApiKey = ( !empty($options['etherscanApiKey']) ? esc_attr( $options['etherscanApiKey'] ) : '' );
        $blockchain_network = '';
        if ( 'mainnet' !== $blockchainNetwork ) {
            $blockchain_network = '-' . $blockchainNetwork;
        }
        $token_tx_list_api_url = 'https://api' . $blockchain_network . '.etherscan.io/api?module=account&action=tokentx&address=%s&startblock=0&endblock=99999999&sort=desc&apikey=' . $etherscanApiKey;
        return $token_tx_list_api_url;
    }
    
    function ETHEREUM_ICO_get_ethprice_api_url()
    {
        global  $ETHEREUM_ICO_options ;
        $options = stripslashes_deep( $ETHEREUM_ICO_options );
        $etherscanApiKey = ( !empty($options['etherscanApiKey']) ? esc_attr( $options['etherscanApiKey'] ) : '' );
        $ethprice_api_url = "https://api.etherscan.io/api?module=stats&action=ethprice&apikey=" . $etherscanApiKey;
        return $ethprice_api_url;
    }
    
    function ETHEREUM_ICO_enqueue_script()
    {
        global  $ETHEREUM_ICO_plugin_url_path ;
        global  $ETHEREUM_ICO_plugin_dir ;
        global  $ETHEREUM_ICO_options ;
        $min = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ? '' : '.min' );
        //        if (!wp_script_is('web3', 'queue') && !wp_script_is('web3', 'done')) {
        //            wp_dequeue_script('web3');
        //            wp_deregister_script('web3');
        //            wp_register_script(
        //                    'web3',
        //                    $ETHEREUM_ICO_plugin_url_path . "/web3{$min}.js", array('jquery'), '0.20.6'
        //            );
        //        }
        //        if (!wp_script_is('ethereum-ico', 'queue') && !wp_script_is('ethereum-ico', 'done')) {
        //            wp_dequeue_script('ethereum-ico');
        //            wp_deregister_script('ethereum-ico');
        //            wp_register_script(
        //                    'ethereum-ico',
        //                    $ETHEREUM_ICO_plugin_url_path . '/ethereum-ico.js', array('jquery', 'web3'), '2.3.12'
        //            );
        //        }
        // 1. runtime~main
        // 2. vendors
        // 3. main
        $runtimeMain = null;
        $vendors = null;
        $main = null;
        $files = scandir( $ETHEREUM_ICO_plugin_dir . "/js/" );
        foreach ( $files as $filename ) {
            // @see https://stackoverflow.com/a/173876/4256005
            $ext = pathinfo( $filename, PATHINFO_EXTENSION );
            if ( 'js' !== $ext ) {
                continue;
            }
            $parts = explode( '.', $filename );
            if ( count( $parts ) < 3 ) {
                continue;
            }
            list( $name, $versionHash, $ext ) = $parts;
            switch ( $name ) {
                case 'runtime~main':
                    $runtimeMain = [ $filename, $versionHash ];
                    break;
                case 'vendors':
                    $vendors = [ $filename, $versionHash ];
                    break;
                case 'main':
                    $main = [ $filename, $versionHash ];
                    break;
                default:
                    break;
            }
        }
        
        if ( !wp_script_is( 'ethereum-ico-runtime-main', 'queue' ) && !wp_script_is( 'ethereum-ico-runtime-main', 'done' ) ) {
            wp_dequeue_script( 'ethereum-ico-runtime-main' );
            wp_deregister_script( 'ethereum-ico-runtime-main' );
            wp_register_script(
                'ethereum-ico-runtime-main',
                $ETHEREUM_ICO_plugin_url_path . "/js/" . $runtimeMain[0],
                array( 'jquery' ),
                $runtimeMain[1]
            );
        }
        
        
        if ( !wp_script_is( 'ethereum-ico-vendors', 'queue' ) && !wp_script_is( 'ethereum-ico-vendors', 'done' ) ) {
            wp_dequeue_script( 'ethereum-ico-vendors' );
            wp_deregister_script( 'ethereum-ico-vendors' );
            wp_register_script(
                'ethereum-ico-vendors',
                $ETHEREUM_ICO_plugin_url_path . "/js/" . $vendors[0],
                array( 'ethereum-ico-runtime-main' ),
                $vendors[1]
            );
        }
        
        
        if ( !wp_script_is( 'ethereum-ico-main', 'queue' ) && !wp_script_is( 'ethereum-ico-main', 'done' ) ) {
            wp_dequeue_script( 'ethereum-ico-main' );
            wp_deregister_script( 'ethereum-ico-main' );
            wp_register_script(
                'ethereum-ico-main',
                $ETHEREUM_ICO_plugin_url_path . "/js/" . $main[0],
                array( 'ethereum-ico-vendors', 'wp-i18n' ),
                $main[1]
            );
        }
        
        //        wp_enqueue_script('ethereum-ico-main');
        $attributes = shortcode_atts( array(), array(), 'ethereum-ico' );
        $options = $ETHEREUM_ICO_options;
        $tokenName = ( !empty($attributes['tokenname']) ? $attributes['tokenname'] : (( !empty($options['tokenname']) ? esc_attr( $options['tokenname'] ) : "TESTCOIN" )) );
        $blockchain_network = ETHEREUM_ICO_getBlockchainNetwork();
        $coinList = ( !empty($options['coinList']) ? esc_attr( $options['coinList'] ) : '' );
        // remove all whitespaces
        $coinList = preg_replace( '/\\s+/', '', $coinList );
        $softcap = ( !empty($options['softcap']) ? esc_attr( $options['softcap'] ) : "" );
        $hardcap = ( !empty($options['hardcap']) ? esc_attr( $options['hardcap'] ) : "10000" );
        $private_sale_seed = "0";
        $base_currency = ( !empty($options['base_currency']) ? esc_attr( $options['base_currency'] ) : ETHEREUM_ICO_getBlockchainCurrencyTicker() );
        $base_symbol = ( !empty($options['base_symbol']) ? esc_attr( $options['base_symbol'] ) : '' );
        $icoperiod = ( !empty($options['icoperiod']) ? esc_attr( $options['icoperiod'] ) : '30' );
        $icostart = ( !empty($options['icostart']) ? $options['icostart'] : '' );
        $tokenAddress = ( !empty($options['tokenAddress']) ? $options['tokenAddress'] : '' );
        $crowdsaleAddress = ( !empty($options['crowdsaleAddress']) ? $options['crowdsaleAddress'] : '' );
        $decimals = ( !empty($options['decimals']) ? esc_attr( $options['decimals'] ) : '1000000000000000000' );
        $tokenRate = ( !empty($options['tokenRate']) ? esc_attr( $options['tokenRate'] ) : '1' );
        $contractABI = trim( ( !empty($options['contractABI']) ? $options['contractABI'] : '[]' ) );
        if ( empty($contractABI) ) {
            $contractABI = '[]';
        }
        $bounty = '[]';
        $txData = '0x';
        $referralArgumentName = 'icoreferral';
        $gaslimit = ( !empty($options['gaslimit']) ? esc_attr( $options['gaslimit'] ) : "200000" );
        $gasprice = ( !empty($options['gasprice']) ? esc_attr( $options['gasprice'] ) : "21" );
        $rateData = ETHEREUM_ICO_get_rate_data();
        $rateDataEmpty = 'null';
        $rateDataFiat = ETHEREUM_ICO_get_rate_data_fiat();
        $coins = array();
        if ( $coinList ) {
            $coins = explode( ',', str_replace( " ", "", $coinList ) );
        }
        wp_localize_script( 'ethereum-ico-main', 'ico', array(
            'coins'                        => esc_html( json_encode( $coins ) ),
            'tokenName'                    => esc_html( $tokenName ),
            'rateData'                     => esc_html( ( is_null( $rateData[0] ) ? ( !empty($rateData[1]) ? $rateData[1] : $rateDataEmpty ) : $rateDataEmpty ) ),
            'rateDataFiat'                 => esc_html( $rateDataFiat ),
            'tokenRate'                    => esc_html( $tokenRate ),
            'percents'                     => esc_html( $bounty ),
            'icoperiod'                    => esc_html( $icoperiod ),
            'start'                        => esc_html( $icostart ),
            'web3Endpoint'                 => esc_html( ETHEREUM_ICO_getWeb3Endpoint() ),
            'blockchain_network'           => esc_html( $blockchain_network ),
            'tokenAddress'                 => esc_html( $tokenAddress ),
            'crowdsaleAddress'             => esc_html( $crowdsaleAddress ),
            'decimals'                     => esc_html( $decimals ),
            'txData'                       => esc_html( $txData ),
            'referralArgumentName'         => esc_html( $referralArgumentName ),
            'gasLimit'                     => esc_html( $gaslimit ),
            'gasPrice'                     => esc_html( $gasprice ),
            'softcap'                      => esc_html( $softcap ),
            'hardcap'                      => esc_html( $hardcap ),
            'private_sale_seed'            => esc_html( $private_sale_seed ),
            'base_currency'                => esc_html( $base_currency ),
            'base_symbol'                  => esc_html( $base_symbol ),
            'currency_ticker'              => esc_html( ETHEREUM_ICO_getBlockchainCurrencyTicker() ),
            'tokenTxListAPIURLTemplate'    => esc_html( ETHEREUM_ICO_get_token_tx_list_api_url_template() ),
            'internalTxListAPIURLTemplate' => esc_html( ETHEREUM_ICO_get_internal_tx_list_api_url_template() ),
            'txListAPIURLTemplate'         => esc_html( ETHEREUM_ICO_get_tx_list_api_url_template() ),
            'txHashPathTemplate'           => esc_html( ETHEREUM_ICO_get_txhash_path_template() ),
            'addressPathTemplate'          => esc_html( ETHEREUM_ICO_get_address_path_template() ),
            'ethprice_api_url'             => esc_html( ETHEREUM_ICO_get_ethprice_api_url() ),
            'str_download_metamask'        => __( 'Download MetaMask', 'ethereum-ico' ),
            'str_unlock_metamask_account'  => __( 'Unlock your MetaMask account please', 'ethereum-ico' ),
            'str_account_balance_failure'  => __( 'Failed to get account balance', 'ethereum-ico' ),
            'str_mm_network_mismatch'      => __( 'MetaMask network mismatch. Choose another network or ask site administrator.', 'ethereum-ico' ),
            'str_network_unknown'          => __( 'This is an unknown network.', 'ethereum-ico' ),
            'str_copied_msg'               => __( 'Copied to clipboard', 'ethereum-ico' ),
            'str_tx_rejected'              => __( 'You have rejected the token buy operation.', 'ethereum-ico' ),
            'str_tx_success'               => __( 'Success! Tx hash: ', 'ethereum-ico' ),
            'str_contract_get_failure'     => __( 'Failed to get contract', 'ethereum-ico' ),
            'str_empty_address_error'      => __( 'Empty address requested for load_transactions!', 'ethereum-ico' ),
            'str_table_days_label'         => __( ' days', 'ethereum-ico' ),
            'str_table_hours_label'        => __( ' hours', 'ethereum-ico' ),
            'str_table_minutes_label'      => __( ' minutes', 'ethereum-ico' ),
            'str_kilo_label'               => __( 'K', 'ethereum-ico' ),
            'str_mega_label'               => __( 'M', 'ethereum-ico' ),
            'str_currency_display_format'  => __( '%1$s%2$s%3$s', 'ethereum-ico' ),
            'str_percent_complete_format'  => __( '%s%% Complete', 'ethereum-ico' ),
            'str_table_recently_label'     => __( 'recently', 'ethereum-ico' ),
            'str_hard_cap_label'           => __( 'Hard:&nbsp;', 'ethereum-ico' ),
            'str_soft_cap_label'           => __( 'Soft:&nbsp;', 'ethereum-ico' ),
            'str_currency_unknown_error'   => sprintf( __( 'Currency is unknown or the %s is not configured correctly.', 'ethereum-ico' ), __( "openexchangerates.org App Id", 'ethereum-ico' ) ),
        ) );
    }
    
    add_action( 'wp_enqueue_scripts', 'ETHEREUM_ICO_enqueue_script' );
    /**
     * Admin Options
     */
    
    if ( is_admin() ) {
        include_once $ETHEREUM_ICO_plugin_dir . '/settings/ico.php';
        include_once $ETHEREUM_ICO_plugin_dir . '/settings/widget.php';
        include_once $ETHEREUM_ICO_plugin_dir . '/settings/blockchain.php';
        include_once $ETHEREUM_ICO_plugin_dir . '/settings/api_keys.php';
        include_once $ETHEREUM_ICO_plugin_dir . '/settings/advanced_blockchain.php';
        include_once $ETHEREUM_ICO_plugin_dir . '/ethereum-ico.admin.php';
    }
    
    function ETHEREUM_ICO_add_menu_link()
    {
        $page = add_options_page(
            __( 'EthereumICO Settings', 'ethereum-ico' ),
            __( 'EthereumICO', 'ethereum-ico' ),
            'manage_options',
            'ethereum-ico',
            'ETHEREUM_ICO_options_page'
        );
    }
    
    add_filter( 'admin_menu', 'ETHEREUM_ICO_add_menu_link' );
    // Place in Option List on Settings > Plugins page
    function ETHEREUM_ICO_actlinks( $links, $file )
    {
        // Static so we don't call plugin_basename on every plugin row.
        static  $this_plugin ;
        if ( !$this_plugin ) {
            $this_plugin = plugin_basename( __FILE__ );
        }
        
        if ( $file == $this_plugin ) {
            $settings_link = '<a href="options-general.php?page=ethereum-ico">' . __( 'Settings', 'ethereum-ico' ) . '</a>';
            array_unshift( $links, $settings_link );
            // before other links
        }
        
        return $links;
    }
    
    add_filter(
        'plugin_action_links',
        'ETHEREUM_ICO_actlinks',
        10,
        2
    );
}

// if ( function_exists( 'ethereumico_freemius_init' ) ) {